# stack_mit_Iterator.py
#verwendet intern eine verkettete Liste

class Stack(object) :
    '''Implementiert einen Stack (Stapel) ...'''
    def __init__(self) :
        '''Konstruktor'''
        self.__oberstes = None
    
    def __len__(self):
        '''ermöglicht len(stack)'''
        return len(self.__inhalte)

    def __iter__(self):
        '''ermöglichen for ...'''
        self.aktuell = self.__oberstes
        return self

    def __next__(self):
        '''ermöglichen for ...''' # aber rückwärts iterieren
        if self.aktuell==None:
            raise StopIteration
        else:
            wert=self.aktuell.GibInhalt()
            self.aktuell=self.aktuell.GibUnteres()
            return wert
    
    def FuegeHinzu (self, objekt) :
        '''legt ein neues Element oben auf den Stapel'''
        neu = Element(objekt)
        if self.__oberstes == None:
            self.__oberstes = neu
        else:
            neu.SetzeUnteres(self.__oberstes)
            self.__oberstes = neu

    def Entferne (self) :
        '''entfernt das Element oben vom Stapel und
        gibt es zurück'''
        if self.__oberstes == None:
            return None
        letztesObjekt = self.__oberstes.GibInhalt()
        self.__oberstes=self.__oberstes.GibUnteres()
        return letztesObjekt
    
    def GibOberstes (self) :
        '''gibt den Inhalt des Elements oben auf dem Stapel zurück'''
        if self.IstLeer():
            return None
        return self.__oberstes.GibInhalt()
        
    def GibLaenge (self) :
        '''gibt die aktuelle Länge des Stapels zurück'''
        laenge=0
        for element in self:
            laenge+=1
        return laenge
        
    def IstLeer (self) :
        '''gibt zurück, ob der Stapel leer ist'''
        return self.__oberstes == None

## --------------------------------------------
class Element(object) :
    '''Klasse für ein Glied einer (hier rueckwaerts)
    verketteten Liste fuer einen Stapel
    Der Inhalt kann nachträglich nicht gesetzt werden.'''
    def __init__(self, inhalt) :
        self.__inhalt = inhalt # object
        self.__naechstes = None # Element_WS
        
    def SetzeUnteres (self, nachfolger) :
        self.__naechstes = nachfolger
        
    def GibInhalt (self) :
        return self.__inhalt
        
    def GibUnteres (self) :
        return self.__naechstes

### ------------- Tests ------------------
import unittest

class TestStack(unittest.TestCase):

    def setUp(self):
        self.stack = Stack()
    
    def test_Initialisierung(self):
        self.assertTrue(self.stack.IstLeer())
        self.assertEqual(self.stack.GibLaenge(), 0)
        self.assertEqual(self.stack.GibOberstes(), None)
        # Problem Entferne
        self.assertEqual(self.stack.Entferne(), None)

    def test_Aktion(self):
        self.stack.FuegeHinzu('Hund')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==1)
        self.assertEqual(self.stack.GibOberstes(), 'Hund')
        
        self.stack.FuegeHinzu('Katze')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==2)
        self.assertEqual(self.stack.GibOberstes(), 'Katze')
        
        self.stack.FuegeHinzu('Vogel')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==3)
        self.assertEqual(self.stack.GibOberstes(), 'Vogel')

        
        self.assertEqual(self.stack.Entferne(), 'Vogel')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==2)
        self.assertEqual(self.stack.GibOberstes(), 'Katze')
        
        self.assertEqual(self.stack.Entferne(), 'Katze')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==1)
        self.assertEqual(self.stack.GibOberstes(), 'Hund')
        
        self.assertEqual(self.stack.Entferne(), 'Hund')
        self.assertTrue(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==0)
        self.assertEqual(self.stack.GibOberstes(), None)

        # Problem: Was liefert Entferne jetzt?
        self.assertEqual(self.stack.Entferne(), None)

    def test_Iteration(self):
        self.stack.FuegeHinzu('Hund')
        self.stack.FuegeHinzu('Katze')
        self.stack.FuegeHinzu('Vogel')
        ausgabe = []
        for element in self.stack:
            ausgabe.append(element)
        self.assertEqual(ausgabe, ['Vogel', 'Katze', 'Hund'])

if __name__ == '__main__':
    unittest.main()
