# stack_mit_Iterator_Typ_Liste.py
class Stack(object) :
    '''Implementiert einen Stack (Stapel) ...'''
    def __init__(self) :
        '''Konstruktor'''
        self.__inhalte = []
    
    def __len__(self):
        '''ermöglicht len(stack)'''
        return len(self.__inhalte)

    def __iter__(self):
        '''ermöglichen for ...'''
        self.index = len(self.__inhalte)-1
        return self

    def __next__(self):
        '''ermöglichen for ...''' # aber rückwärts iterieren
        if self.index<0:
            raise StopIteration
        else:
            wert=self.__inhalte[self.index]
            self.index -= 1
            return wert
    
    def FuegeHinzu (self, objekt) :
        '''legt ein neues Element oben auf den Stapel'''
        self.__inhalte.append(objekt)

    def Entferne (self) :
        '''entfernt das Element oben vom Stapel und
        gibt es zurück'''
        if len(self.__inhalte)==0:
            return None
        indexLetztes=self.GibLaenge()-1
        letztesObjekt = self.__inhalte[indexLetztes]
        self.__inhalte=self.__inhalte[:indexLetztes]
        return letztesObjekt
    
    def GibOberstes (self) :
        '''gibt das Element oben auf dem Stapel zurück'''
        if len(self.__inhalte)==0:
            return None
        return self.__inhalte[self.GibLaenge()-1]
        
    def GibLaenge (self) :
        '''gibt die aktuelle Länge des Stapels zurück'''
        return len(self.__inhalte)
        
    def IstLeer (self) :
        '''gibt zurück, ob der Stapel leer ist'''
        return (len(self.__inhalte) == 0)    

### ------------- Tests ------------------
import unittest

class TestStack(unittest.TestCase):

    def setUp(self):
        self.stack = Stack()
    
    def test_Initialisierung(self):
        self.assertTrue(self.stack.IstLeer())
        self.assertEqual(self.stack.GibLaenge(), 0)
        self.assertEqual(self.stack.GibOberstes(), None)
        # Problem Entferne
        self.assertEqual(self.stack.Entferne(), None)

    def test_Aktion(self):
        self.stack.FuegeHinzu('Hund')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==1)
        self.assertEqual(self.stack.GibOberstes(), 'Hund')
        
        self.stack.FuegeHinzu('Katze')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==2)
        self.assertEqual(self.stack.GibOberstes(), 'Katze')
        
        self.stack.FuegeHinzu('Vogel')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==3)
        self.assertEqual(self.stack.GibOberstes(), 'Vogel')

        
        self.assertEqual(self.stack.Entferne(), 'Vogel')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==2)
        self.assertEqual(self.stack.GibOberstes(), 'Katze')
        
        self.assertEqual(self.stack.Entferne(), 'Katze')
        self.assertFalse(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==1)
        self.assertEqual(self.stack.GibOberstes(), 'Hund')
        
        self.assertEqual(self.stack.Entferne(), 'Hund')
        self.assertTrue(self.stack.IstLeer())
        self.assertTrue(self.stack.GibLaenge()==0)
        self.assertEqual(self.stack.GibOberstes(), None)

        # Problem: Was liefert Entferne jetzt?
        self.assertEqual(self.stack.Entferne(), None)

    def test_Iteration(self):
        self.stack.FuegeHinzu('Hund')
        self.stack.FuegeHinzu('Katze')
        self.stack.FuegeHinzu('Vogel')
        ausgabe = []
        for element in self.stack:
            ausgabe.append(element)
        self.assertEqual(ausgabe, ['Vogel', 'Katze', 'Hund'])

if __name__ == '__main__':
    unittest.main()
